import {fileDirFormat, fileDirFormatArray, filePathSplit, getFileDirByPath} from "./PathOperate";
import {isObject} from "formik";
import {isEmpty} from "./ObjectUtils";

export class FileTree {
    constructor(fileName,filePath,dirFlag,children) {
        this.fileName = fileName;
        this.filePath = filePath;
        this.dirFlag = dirFlag;
        this.children = children;
        this.pass=0
        this.end=0
    }
}

export function insertNode(root,fileMessage) {
    // let copy = JSON.parse(JSON.stringify(root))
    // let currentNode = copy;
    let currentNode = root;
    let fileDir;
    if (fileMessage.dirFlag){
        fileDir=fileMessage.filePath
    }else {
        fileDir=getFileDirByPath(fileMessage.filePath)
    }

    let fileDirSplit = filePathSplit(fileDir).filter(fileD=>!isObject(fileD)&&fileD!=="");
    for (let i = 0; i < fileDirSplit.length; i++) {
        let find = currentNode.children.find(file=>file.dirFlag&&file.fileName===fileDirSplit[i]);
        if (find &&!isEmpty(find.fileName)){
            currentNode=find;
            currentNode.pass=currentNode.pass+1
        }else {
            let newNode = new FileTree(fileDirSplit[i],fileDirFormatArray(fileDirSplit.slice(0,i+1)),true,[]);
            currentNode.children.push(newNode)
            currentNode=newNode
            currentNode.pass=currentNode.pass+1
        }
        if (i===fileDirSplit.length-1){
            currentNode.end =1
            if (!fileMessage.dirFlag){
                currentNode.children.push(fileMessage)
            } else {
                currentNode.children = fileMessage.children
            }
        }
    }
    // return copy;
}

export function removeNode(root,fileMessage) {
    let currentNode = root;
    let fileDir;
    if (fileMessage.dirFlag){
        fileDir=fileMessage.filePath
    }else {
        fileDir=getFileDirByPath(fileMessage.filePath)
    }
    let fileDirSplit = filePathSplit(fileDir).filter(fileD=>!isObject(fileD)&&fileD!=="");
    for (let i = 0; i < fileDirSplit.length; i++) {
        if (i===fileDirSplit.length-1) {
            if (fileMessage.dirFlag) {
                currentNode.children = currentNode.children.filter(file =>
                    file.fileName !== fileDirSplit[i] && file.dirFlag)
                break
            } else {
                currentNode.children = currentNode.children.filter(file =>
                    file.fileName !== fileMessage.fileName && !file.dirFlag)
                break
            }
        }
        let find = currentNode.children.find(file=>file.dirFlag&&file.fileName===fileDirSplit[i]);
        if (!isEmpty(find)){
            currentNode=find;
        }else {
            break
        }
    }
}

export function updateNode(root,fileMessage,newFileMessage) {
    let currentNode = root;
    let fileDir;
    if (fileMessage.dirFlag){
        fileDir=fileMessage.filePath
    }else {
        fileDir=getFileDirByPath(fileMessage.filePath)
    }

    let fileDirSplit = filePathSplit(fileDir).filter(fileD=>!isObject(fileD)&&fileD!=="");
    for (let i = 0; i < fileDirSplit.length; i++) {
        if (fileMessage.dirFlag){
            if (i===fileDirSplit.length-1){
                let node =currentNode.children.find(file=>
                    file.fileName===fileDirSplit[i]&&file.dirFlag);
                node.fileName=newFileMessage.fileName
                node.filePath=newFileMessage.filePath
                node.dirFlag=newFileMessage.dirFlag
                node.children=newFileMessage.children
            }
        }else {
            if (i===fileDirSplit.length-1){
                let node=currentNode.children.find(file=>
                    file.fileName===fileMessage.fileName&&!file.dirFlag)
                node.fileName=newFileMessage.fileName
                node.filePath=newFileMessage.filePath
                node.dirFlag=newFileMessage.dirFlag
                node.children=newFileMessage.children
            }
        }
        let find = currentNode.children.find(file=>file.dirFlag&&file.fileName===fileDirSplit[i]);
        if (!isEmpty(find)){
            currentNode=find;
        }else {
            break
        }
    }
}
